extern int    MAGIC         = 20060613;
extern double TakeProfit    = 5;
extern double Lots          = 0.1;
extern double TrailingStop  = 0;

extern double    timeframe1    = 5.0;
extern double    timeframe2    = 15.0;
extern double    timeframe3    = 60.0;

extern double    AskSTOPLoss  = 40.0;
extern double    BidSTOPLoss  = 40.0;

int init() {
    return(0);
}
int deinit() {
    return(0);
}

int start() {
    double prevPrice, currPrice;
    double currPSAR1,currPSAR2,currPSAR3,prevPSAR1,prevPSAR2;
    double currRSI;
    double fraktup,fraktlo;
    double DIplus,DIminus;
    int cnt=0, total;
    bool flag;

    int back, i;

    if(Bars<100) {
        Print("bars less than 100");
        return(0); //    100 
    }
    if (TakeProfit<4) {
        Print("TakeProfit less than 4");
        return(0); //  TakeProfit
    }

    currPSAR1=iSAR(NULL,timeframe1,0.02,0.2,0);
    prevPSAR1=iSAR(NULL,timeframe1,0.02,0.2,1);

    currPSAR2=iSAR(NULL,timeframe2,0.02,0.2,0);
    prevPSAR2=iSAR(NULL,timeframe2,0.02,0.2,1);

    currPSAR3=iSAR(NULL,timeframe3,0.02,0.2,0);

    fraktup=iFractals(NULL,timeframe1,MODE_UPPER,3);
    fraktlo=iFractals(NULL,timeframe1,MODE_LOWER,3);

    DIplus=iADX(NULL,timeframe3,14,PRICE_CLOSE,MODE_PLUSDI,0);
    DIminus=iADX(NULL,timeframe3,14,PRICE_CLOSE,MODE_MINUSDI,0);

    currRSI=iRSI(NULL,timeframe1,14,PRICE_CLOSE,0) ;
    currPrice = iClose(NULL,0,0);
    prevPrice = iClose(NULL,0,1);
    if(CurTime()-OrderOpenTime()>3600 &&!ExistPosition()) {
        if(AccountFreeMargin()<(100*Lots)) {
            Print("We have no money");
            return(0); //   - 
        }
        if (prevPSAR1 < prevPrice &&
                currPSAR1 > currPrice &&
                currPSAR2 > currPrice &&
                currPSAR3 > currPrice &&
                currRSI > 40          &&
                fraktup >0            &&
                fraktup > currPrice   &&
                DIminus > DIplus ) {
            OrderSend(Symbol(),OP_SELL,Lots,Bid,3,Bid+BidSTOPLoss*Point,Bid-TakeProfit*Point,"RSI ",MAGIC,0,Red); // 
            if(GetLastError()==0) Print("Order opened : ",OrderOpenPrice());
            return(0);
        }
        if (prevPSAR1 > prevPrice &&
                currPSAR1 < currPrice &&
                currPSAR2 < currPrice &&
                currPSAR3 < currPrice &&
                currRSI < 60          &&
                fraktlo > 0           &&
                fraktlo < currPrice   &&
                DIminus < DIplus ) {
            OrderSend(Symbol(),OP_BUY,Lots,Ask,3,Ask-AskSTOPLoss*Point,Ask+TakeProfit*Point,"RSI ",MAGIC,0,Green);
            if(GetLastError()==0) Print("Order opened : ",OrderOpenPrice());

            return(0);
        }
    }
    total=OrdersTotal();
    for(cnt=0;cnt<total;cnt++) {
        OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
        if(OrderSymbol()==Symbol()) {
            if(OrderType()==OP_BUY) {
                if(TrailingStop>0) {
                    if(Bid-OrderOpenPrice()>Point*TrailingStop) {
                        if(OrderStopLoss()<Bid-Point*TrailingStop) {
                            OrderModify(OrderTicket(),OrderOpenPrice(),Bid-Point*TrailingStop,OrderTakeProfit(),0,Green);
                            return(0);
                        }
                    }
                }
                if ((CurTime()-OrderOpenTime())>9000) {
                    OrderClose(OrderTicket(), OrderLots(), Bid, 3, Blue);
                }
            }
            if (OrderType()==OP_SELL) {
                if(TrailingStop>0) {
                    if((OrderOpenPrice()-Ask)>(Point*TrailingStop)) {
                        if(OrderStopLoss()==0.0 ||
                                OrderStopLoss()>(Ask+Point*TrailingStop)) {
                            OrderModify(OrderTicket(),OrderOpenPrice(),Ask+Point*TrailingStop,OrderTakeProfit(),0,Khaki);
                            return(0);
                        }
                    }
                }
                if ((CurTime()-OrderOpenTime())>9000) {
                    OrderClose(OrderTicket(), OrderLots(), Ask, 3, Blue);
                }
            }
        }
    }
    return(0);
}
bool ExistPosition() {
    bool Exist=False;
    for (int i=0; i<OrdersTotal(); i++) {
        if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) {
            if (OrderSymbol()==Symbol() && OrderMagicNumber()==MAGIC) {
                if (OrderType()==OP_BUY || OrderType()==OP_SELL) {
                    Exist=True;
                    break;
                }
            }
        }
    }
    return(Exist);
}
